module.exports = (defaultCredentials = null) -> (req, res, next) ->
    authorization = req?.headers?.authorization
    req.credentials = defaultCredentials if defaultCredentials?
    return next() unless authorization?
    [scheme, base64Credentials] = authorization.split ' '
    credentials = new Buffer(base64Credentials, 'base64').toString()

    [user, passwordParts...] = credentials.split ':'
    req.credentials =
        user: user
        password: passwordParts.join ':'
    next()

