permCode = 301
tempCode = 302

module.exports = (req, res, next) ->

    req.flash = (message, type = 'info') ->
        throw new Error 'missing session middleware' unless req?.session?
        console.info 'flash', type, message
        req.session.flash =
            message: message
            type: type

    res.redirect = (location, permanent = false) ->
        statusCode = if permanent then permCode else tempCode
        isBack = location is 'back'
        location = req.url if isBack
        console.info "redirect to #{location}"
        res.writeHead statusCode, {Location: location}
        res.end()

    res.error = (err) ->
        console.log err
        res.writeHead 500
        res.end 'an error occured.'

    res.sendJSON = (obj) ->
        res.setHeader 'Vary', 'Accept-Encoding'
        res.setHeader 'Content-Type', 'application/json; charset=utf-8'
        res.write JSON.stringify(obj)
        res.end()

    next()
